#[derive(Clone, Copy, Debug, PartialEq)]
/// How to calculate the standard deviation.
pub enum StandardDeviationMode {
    /// Calculate **population** standard deviation.
    Population,

    /// Calculate **sample** standard deviation.
    Sample,
}

impl Default for StandardDeviationMode {
    fn default() -> Self {
        StandardDeviationMode::Sample
    }
}
